# gFTL-shared
Provides common gFTL containers of Fortran intrinsic types that are encountered frequently.

Starting with v1.3.0,  gFTL-shared now includes a new library based upon v2 versions of gFTL containers.   The release remains backward compatible; if users want to try the new style of containers they should link against GFTL_SHARED::gftl-shared2.    After a trial period, the v2 variants will become the default.  Projects that want to avoid upgrading can begin to link against GFTL_SHARED::gftl-shared1.    

See https://github.com/Goddard-Fortran-Ecosystem/gFTL   for more information about the v2 containers.

module gFTL_Integer32StringMap
  use, intrinsic:: iso_fortran_env, only: INT32

#define _key type(integer(kind=INT32))
#include "types/value_deferredLengthString.inc"
#define _map Integer32StringMap
#define _iterator Integer32StringMapIterator
#define _pair Integer32StringPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_Integer32StringMap

module gFTL_IntegerUnlimitedMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer32UnlimitedMap, only: IntegerUnlimitedMap => Integer32UnlimitedMap
  use gFTL_Integer32UnlimitedMap, only: IntegerUnlimitedMapIterator => Integer32UnlimitedMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64UnlimitedMap, only: IntegerUnlimitedMap => Integer64UnlimitedMap
  use gFTL_Integer64UnlimitedMap, only: IntegerUnlimitedMapIterator => Integer64UnlimitedMapIterator

#else

 
#  define _key type(integer)
#  include "types/value_unlimitedPoly.inc"
#  define _map IntegerUnlimitedMap
#  define _iterator IntegerUnlimitedMapIterator
#  define _pair IntegerUnlimitedPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerUnlimitedMap

module gFTL1_IntegerComplex64Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32Complex64Map, only: IntegerComplex64Map => Integer32Complex64Map
   use gFTL1_Integer32Complex64Map, only: IntegerComplex64MapIterator => Integer32Complex64MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64Complex64Map, only: IntegerComplex64Map => Integer64Complex64Map
   use gFTL1_Integer64Complex64Map, only: IntegerComplex64MapIterator => Integer64Complex64MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL64

#  define _key type(integer)
#  define _value type(complex(kind=REAL64))
#  define _map IntegerComplex64Map
#  define _iterator IntegerComplex64MapIterator
#  define _pair IntegerComplex64Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerComplex64Map

module gFTL_IntegerComplex64Map
   use gFTL1_IntegerComplex64Map
end module gFTL_IntegerComplex64Map

module gFTL_StringIntegerMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_StringInteger32Map, only: StringIntegerMap => StringInteger32Map
  use gFTL_StringInteger32Map, only: StringIntegerMapIterator => StringInteger32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_StringInteger64Map, only: StringIntegerMap => StringInteger64Map
  use gFTL_StringInteger64Map, only: StringIntegerMapIterator => StringInteger64MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(integer)
#  define _map StringIntegerMap
#  define _iterator StringIntegerMapIterator
#  define _pair StringIntegerPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_StringIntegerMap

module gFTL1_Integer32DoubleMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Integer32Real64Map, only: Integer32DoubleMap => Integer32Real64Map
  use gFTL1_Integer32Real64Map, only: Integer32DoubleMapIterator => Integer32Real64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_Integer32Real128Map, only: Integer32DoubleMap => Integer32Real128Map
  use gFTL1_Integer32Real128Map, only: Integer32DoubleMapIterator => Integer32Real128MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT32
 
#  define _key type(integer(kind=INT32))
#  define _value type(double precision)
#  define _map Integer32DoubleMap
#  define _iterator Integer32DoubleMapIterator
#  define _pair Integer32DoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer32DoubleMap

module gFTL_Integer32DoubleMap
   use gFTL1_Integer32DoubleMap
end module gFTL_Integer32DoubleMap

module gFTL1_Complex64Vector
  use, intrinsic :: iso_fortran_env, only: REAL64

#define _type type(complex(kind=REAL64))
#define _vector Complex64Vector
#define _vectoriterator Complex64VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL1_Complex64Vector

module gFTL_Complex64Vector
   use gFTL1_Complex64Vector
end module gFTL_Complex64Vector

module gFTL_Integer32Complex128Map
  use, intrinsic:: iso_fortran_env, only: INT32, REAL128

#define _key type(integer(kind=INT32))
#define _value type(complex(kind=REAL128))
#define _map Integer32Complex128Map
#define _iterator Integer32Complex128MapIterator
#define _pair Integer32Complex128Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_Integer32Complex128Map

module gFTL_Real64Vector
  use, intrinsic :: iso_fortran_env, only: REAL64

#define _type type(real(kind=REAL64))
#define _vector Real64Vector
#define _vectoriterator Real64VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL_Real64Vector

module gFTL1_StringIntegerMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_StringInteger32Map, only: StringIntegerMap => StringInteger32Map
  use gFTL1_StringInteger32Map, only: StringIntegerMapIterator => StringInteger32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_StringInteger64Map, only: StringIntegerMap => StringInteger64Map
  use gFTL1_StringInteger64Map, only: StringIntegerMapIterator => StringInteger64MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(integer)
#  define _map StringIntegerMap
#  define _iterator StringIntegerMapIterator
#  define _pair StringIntegerPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_StringIntegerMap

module gFTL_StringIntegerMap
   use gFTL1_StringIntegerMap
end module gFTL_StringIntegerMap

module gFTL_StringInteger32Map
  use, intrinsic:: iso_fortran_env, only: INT32

#include "types/key_deferredLengthString.inc"
#define _value type(integer(kind=INT32))
#define _map StringInteger32Map
#define _iterator StringInteger32MapIterator
#define _pair StringInteger32Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_StringInteger32Map

module gFTL1_IntegerInteger64Map

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32Integer64Map, only: IntegerInteger64Map => Integer32Integer64Map
  use gFTL1_Integer32Integer64Map, only: IntegerInteger64MapIterator => Integer32Integer64MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64Integer64Map, only: IntegerInteger64Map => Integer64Integer64Map
  use gFTL1_Integer64Integer64Map, only: IntegerInteger64MapIterator => Integer64Integer64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer)
#  define _value type(integer(kind=INT64))
#  define _map IntegerInteger64Map
#  define _iterator IntegerInteger64MapIterator
#  define _pair IntegerInteger64Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerInteger64Map

module gFTL_IntegerInteger64Map
   use gFTL1_IntegerInteger64Map
end module gFTL_IntegerInteger64Map

module gFTL_Integer32Real64Map
  use, intrinsic:: iso_fortran_env, only: INT32, REAL64

#define _key type(integer(kind=INT32))
#define _value type(real(kind=REAL64))
#define _map Integer32Real64Map
#define _iterator Integer32Real64MapIterator
#define _pair Integer32Real64Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_Integer32Real64Map

module gFTL1_IntegerLogicalMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32LogicalMap, only: IntegerLogicalMap => Integer32LogicalMap
  use gFTL1_Integer32LogicalMap, only: IntegerLogicalMapIterator => Integer32LogicalMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64LogicalMap, only: IntegerLogicalMap => Integer64LogicalMap
  use gFTL1_Integer64LogicalMap, only: IntegerLogicalMapIterator => Integer64LogicalMapIterator

#else

#  define _key type(integer)
#  define _value type(logical)
#  define _map IntegerLogicalMap
#  define _iterator IntegerLogicalMapIterator
#  define _pair IntegerLogicalPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerLogicalMap

module gFTL_IntegerLogicalMap
   use gFTL1_IntegerLogicalMap
end module gFTL_IntegerLogicalMap

module gFTL1_RealVector

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL1_Real32Vector, only: RealVector => Real32Vector
  use gFTL1_Real32Vector, only: RealVectorIterator => Real32VectorIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Real64Vector, only: RealVector => Real64Vector
  use gFTL1_Real64Vector, only: RealVectorIterator => Real64VectorIterator

#else

#  define _type type(real)
#  define _vector RealVector
#  define _vectoriterator RealVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL1_RealVector

module gFTL_RealVector
   use gFTL1_RealVector
end module gFTL_RealVector

module gFTL_Integer32DoubleComplexMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_Integer32Complex64Map, only: Integer32DoubleComplexMap => Integer32Complex64Map
  use gFTL_Integer32Complex64Map, only: Integer32DoubleComplexMapIterator => Integer32Complex64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_Integer32Complex128Map, only: Integer32DoubleComplexMap => Integer32Complex128Map
  use gFTL_Integer32Complex128Map, only: Integer32DoubleComplexMapIterator => Integer32Complex128MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT32
 
#  define _key type(integer(kind=INT32))
#  define _value type(complex(kind=kind(0.0d0)))
#  define _map Integer32DoubleComplexMap
#  define _iterator Integer32DoubleComplexMapIterator
#  define _pair Integer32DoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_Integer32DoubleComplexMap

module gFTL1_IntegerStringMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32StringMap, only: IntegerStringMap => Integer32StringMap
  use gFTL1_Integer32StringMap, only: IntegerStringMapIterator => Integer32StringMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64StringMap, only: IntegerStringMap => Integer64StringMap
  use gFTL1_Integer64StringMap, only: IntegerStringMapIterator => Integer64StringMapIterator

#else

 
#  define _key type(integer)
#  include "types/value_deferredLengthString.inc"
#  define _map IntegerStringMap
#  define _iterator IntegerStringMapIterator
#  define _pair IntegerStringPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerStringMap

module gFTL_IntegerStringMap
   use gFTL1_IntegerStringMap
end module gFTL_IntegerStringMap

module gFTL_IntegerInteger32Map

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer32Integer32Map, only: IntegerInteger32Map => Integer32Integer32Map
  use gFTL_Integer32Integer32Map, only: IntegerInteger32MapIterator => Integer32Integer32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64Integer32Map, only: IntegerInteger32Map => Integer64Integer32Map
  use gFTL_Integer64Integer32Map, only: IntegerInteger32MapIterator => Integer64Integer32MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT32
 
#  define _key type(integer)
#  define _value type(integer(kind=INT32))
#  define _map IntegerInteger32Map
#  define _iterator IntegerInteger32MapIterator
#  define _pair IntegerInteger32Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerInteger32Map

module gFTL1_IntegerReal128Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32Real128Map, only: IntegerReal128Map => Integer32Real128Map
   use gFTL1_Integer32Real128Map, only: IntegerReal128MapIterator => Integer32Real128MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64Real128Map, only: IntegerReal128Map => Integer64Real128Map
   use gFTL1_Integer64Real128Map, only: IntegerReal128MapIterator => Integer64Real128MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL128

#  define _key type(integer)
#  define _value type(real(kind=REAL128))
#  define _map IntegerReal128Map
#  define _iterator IntegerReal128MapIterator
#  define _pair IntegerReal128Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerReal128Map

module gFTL_IntegerReal128Map
   use gFTL1_IntegerReal128Map
end module gFTL_IntegerReal128Map

module gFTL_IntegerComplex128Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32Complex128Map, only: IntegerComplex128Map => Integer32Complex128Map
   use gFTL_Integer32Complex128Map, only: IntegerComplex128MapIterator => Integer32Complex128MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64Complex128Map, only: IntegerComplex128Map => Integer64Complex128Map
   use gFTL_Integer64Complex128Map, only: IntegerComplex128MapIterator => Integer64Complex128MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL128

#  define _key type(integer)
#  define _value type(complex(kind=REAL128))
#  define _map IntegerComplex128Map
#  define _iterator IntegerComplex128MapIterator
#  define _pair IntegerComplex128Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerComplex128Map

module gFTL1_StringVector

#include "types/deferredLengthString.inc"
#define _vector StringVector
#define _vectoriterator StringVectorIterator

#include "templates/vector.inc"

#undef _vectoriterator
#undef _vector
#undef _type

end module gFTL1_StringVector

module gFTL_StringVector
   use gFTL1_StringVector
end module gFTL_StringVector

module gFTL_LogicalVector

#define _type type(logical)
#define _vector LogicalVector
#define _vectoriterator LogicalVectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type

end module gFTL_LogicalVector

module gFTL1_Complex32Vector
  use, intrinsic :: iso_fortran_env, only: REAL32

#define _type type(complex(kind=REAL32))
#define _vector Complex32Vector
#define _vectoriterator Complex32VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL1_Complex32Vector

module gFTL_Complex32Vector
   use gFTL1_Complex32Vector
end module gFTL_Complex32Vector

module gFTL_IntegerStringMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer32StringMap, only: IntegerStringMap => Integer32StringMap
  use gFTL_Integer32StringMap, only: IntegerStringMapIterator => Integer32StringMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64StringMap, only: IntegerStringMap => Integer64StringMap
  use gFTL_Integer64StringMap, only: IntegerStringMapIterator => Integer64StringMapIterator

#else

 
#  define _key type(integer)
#  include "types/value_deferredLengthString.inc"
#  define _map IntegerStringMap
#  define _iterator IntegerStringMapIterator
#  define _pair IntegerStringPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerStringMap

module gFTL1_StringComplexMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL1_StringComplex32Map, only: StringComplexMap => StringComplex32Map
  use gFTL1_StringComplex32Map, only: StringComplexMapIterator => StringComplex32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL1_StringComplex64Map, only: StringComplexMap => StringComplex64Map
  use gFTL1_StringComplex64Map, only: StringComplexMapIterator => StringComplex64MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(complex)
#  define _map StringComplexMap
#  define _iterator StringComplexMapIterator
#  define _pair StringComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_StringComplexMap

module gFTL_StringComplexMap
   use gFTL1_StringComplexMap
end module gFTL_StringComplexMap

module gFTL_StringUnlimitedMap

#include "types/key_deferredLengthString.inc"
#include "types/value_unlimitedPoly.inc"
#define _map StringUnlimitedMap
#define _iterator StringUnlimitedMapIterator
#define _pair StringUnlimitedPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_StringUnlimitedMap

module gFTL1_IntegerDoubleMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32DoubleMap, only: IntegerDoubleMap => Integer32DoubleMap
   use gFTL1_Integer32DoubleMap, only: IntegerDoubleMapIterator => Integer32DoubleMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64DoubleMap, only: IntegerDoubleMap => Integer64DoubleMap
   use gFTL1_Integer64DoubleMap, only: IntegerDoubleMapIterator => Integer64DoubleMapIterator

#else

#  define _key type(integer)
#  define _value type(double precision)
#  define _map IntegerDoubleMap
#  define _iterator IntegerDoubleMapIterator
#  define _pair IntegerDoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerDoubleMap

module gFTL_IntegerDoubleMap
   use gFTL1_IntegerDoubleMap
end module gFTL_IntegerDoubleMap

module gFTL_StringDoubleComplexMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_StringComplex64Map, only: StringDoubleComplexMap => StringComplex64Map
  use gFTL_StringComplex64Map, only: StringDoubleComplexMapIterator => StringComplex64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_StringComplex128Map, only: StringDoubleComplexMap => StringComplex128Map
  use gFTL_StringComplex128Map, only: StringDoubleComplexMapIterator => StringComplex128MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(complex(kind=kind(0.0d0)))
#  define _map StringDoubleComplexMap
#  define _iterator StringDoubleComplexMapIterator
#  define _pair StringDoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_StringDoubleComplexMap

module gFTL1_Integer32DoubleComplexMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Integer32Complex64Map, only: Integer32DoubleComplexMap => Integer32Complex64Map
  use gFTL1_Integer32Complex64Map, only: Integer32DoubleComplexMapIterator => Integer32Complex64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_Integer32Complex128Map, only: Integer32DoubleComplexMap => Integer32Complex128Map
  use gFTL1_Integer32Complex128Map, only: Integer32DoubleComplexMapIterator => Integer32Complex128MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT32
 
#  define _key type(integer(kind=INT32))
#  define _value type(complex(kind=kind(0.0d0)))
#  define _map Integer32DoubleComplexMap
#  define _iterator Integer32DoubleComplexMapIterator
#  define _pair Integer32DoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer32DoubleComplexMap

module gFTL_Integer32DoubleComplexMap
   use gFTL1_Integer32DoubleComplexMap
end module gFTL_Integer32DoubleComplexMap

module gFTL_RealVector

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL_Real32Vector, only: RealVector => Real32Vector
  use gFTL_Real32Vector, only: RealVectorIterator => Real32VectorIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL_Real64Vector, only: RealVector => Real64Vector
  use gFTL_Real64Vector, only: RealVectorIterator => Real64VectorIterator

#else

#  define _type type(real)
#  define _vector RealVector
#  define _vectoriterator RealVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL_RealVector

module gFTL_Integer64Vector
  use, intrinsic :: iso_fortran_env, only: INT64

#define _type type(integer(kind=INT64))
#define _vector Integer64Vector
#define _vectoriterator Integer64VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL_Integer64Vector

module gFTL_IntegerLogicalMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer32LogicalMap, only: IntegerLogicalMap => Integer32LogicalMap
  use gFTL_Integer32LogicalMap, only: IntegerLogicalMapIterator => Integer32LogicalMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64LogicalMap, only: IntegerLogicalMap => Integer64LogicalMap
  use gFTL_Integer64LogicalMap, only: IntegerLogicalMapIterator => Integer64LogicalMapIterator

#else

#  define _key type(integer)
#  define _value type(logical)
#  define _map IntegerLogicalMap
#  define _iterator IntegerLogicalMapIterator
#  define _pair IntegerLogicalPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerLogicalMap

module gFTL1_StringUnlimitedMap

#include "types/key_deferredLengthString.inc"
#include "types/value_unlimitedPoly.inc"
#define _map StringUnlimitedMap
#define _iterator StringUnlimitedMapIterator
#define _pair StringUnlimitedPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_StringUnlimitedMap

module gFTL_StringUnlimitedMap
   use gFTL1_StringUnlimitedMap
end module gFTL_StringUnlimitedMap

module gFTL1_StringReal128Map
  use, intrinsic:: iso_fortran_env, only: REAL128

#include "types/key_deferredLengthString.inc"
#define _value type(real(kind=REAL128))
#define _map StringReal128Map
#define _iterator StringReal128MapIterator
#define _pair StringReal128Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_StringReal128Map

module gFTL_StringReal128Map
   use gFTL1_StringReal128Map
end module gFTL_StringReal128Map

module gFTL_StringRealMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL_StringReal32Map, only: StringRealMap => StringReal32Map
  use gFTL_StringReal32Map, only: StringRealMapIterator => StringReal32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL_StringReal64Map, only: StringRealMap => StringReal64Map
  use gFTL_StringReal64Map, only: StringRealMapIterator => StringReal64MapIterator

#else
   
#  include "types/key_deferredLengthString.inc"
#  define _value type(real)
#  define _map StringRealMap
#  define _iterator StringRealMapIterator
#  define _pair StringRealPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_StringRealMap

module gFTL1_StringStringMap

#include "types/key_deferredLengthString.inc"
#include "types/value_deferredLengthString.inc"
#define _map StringStringMap
#define _iterator StringStringMapIterator
#define _pair StringStringPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_StringStringMap

module gFTL_StringStringMap
   use gFTL1_StringStringMap
end module gFTL_StringStringMap

module gFTL1_Integer64RealMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL1_Integer64Real32Map, only: Integer64RealMap => Integer64Real32Map
  use gFTL1_Integer64Real32Map, only: Integer64RealMapIterator => Integer64Real32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Integer64Real64Map, only: Integer64RealMap => Integer64Real64Map
  use gFTL1_Integer64Real64Map, only: Integer64RealMapIterator => Integer64Real64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(real)
#  define _map Integer64RealMap
#  define _iterator Integer64RealMapIterator
#  define _pair Integer64RealPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer64RealMap

module gFTL_Integer64RealMap
   use gFTL1_Integer64RealMap
end module gFTL_Integer64RealMap

module gFTL_StringStringMap

#include "types/key_deferredLengthString.inc"
#include "types/value_deferredLengthString.inc"
#define _map StringStringMap
#define _iterator StringStringMapIterator
#define _pair StringStringPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_StringStringMap

module gFTL1_Integer64UnlimitedMap
  use, intrinsic:: iso_fortran_env, only: INT64

#define _key type(integer(kind=INT64))
#include "types/value_unlimitedPoly.inc"
#define _map Integer64UnlimitedMap
#define _iterator Integer64UnlimitedMapIterator
#define _pair Integer64UnlimitedPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_Integer64UnlimitedMap

module gFTL_Integer64UnlimitedMap
   use gFTL1_Integer64UnlimitedMap
end module gFTL_Integer64UnlimitedMap

module gFTL1_ComplexVector

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL1_Complex32Vector, only: ComplexVector => Complex32Vector
  use gFTL1_Complex32Vector, only: ComplexVectorIterator => Complex32VectorIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Complex64Vector, only: ComplexVector => Complex64Vector
  use gFTL1_Complex64Vector, only: ComplexVectorIterator => Complex64VectorIterator

#else

#  define _type type(complex)
#  define _vector ComplexVector
#  define _vectoriterator ComplexVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL1_ComplexVector

module gFTL_ComplexVector
   use gFTL1_ComplexVector
end module gFTL_ComplexVector

module gFTL1_Integer32RealMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL_Integer32Real32Map, only: Integer32RealMap => Integer32Real32Map
  use gFTL_Integer32Real32Map, only: Integer32RealMapIterator => Integer32Real32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL_Integer32Real64Map, only: Integer32RealMap => Integer32Real64Map
  use gFTL_Integer32Real64Map, only: Integer32RealMapIterator => Integer32Real64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT32
 
#  define _key type(integer(kind=INT32))
#  define _value type(real)
#  define _map Integer32RealMap
#  define _iterator Integer32RealMapIterator
#  define _pair Integer32RealPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer32RealMap

module gFTL_Integer32RealMap
   use gFTL1_Integer32RealMap
end module gFTL_Integer32RealMap

module gFTL1_Integer64ComplexMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL1_Integer64Complex32Map, only: Integer64ComplexMap => Integer64Complex32Map
  use gFTL1_Integer64Complex32Map, only: Integer64ComplexMapIterator => Integer64Complex32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Integer64Complex64Map, only: Integer64ComplexMap => Integer64Complex64Map
  use gFTL1_Integer64Complex64Map, only: Integer64ComplexMapIterator => Integer64Complex64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(complex)
#  define _map Integer64ComplexMap
#  define _iterator Integer64ComplexMapIterator
#  define _pair Integer64ComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer64ComplexMap


module gFTL_Integer64ComplexMap
   use gFTL1_Integer64ComplexMap
end module gFTL_Integer64ComplexMap

module gFTL_Integer64ComplexMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL_Integer64Complex32Map, only: Integer64ComplexMap => Integer64Complex32Map
  use gFTL_Integer64Complex32Map, only: Integer64ComplexMapIterator => Integer64Complex32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL_Integer64Complex64Map, only: Integer64ComplexMap => Integer64Complex64Map
  use gFTL_Integer64Complex64Map, only: Integer64ComplexMapIterator => Integer64Complex64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(complex)
#  define _map Integer64ComplexMap
#  define _iterator Integer64ComplexMapIterator
#  define _pair Integer64ComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_Integer64ComplexMap

module gFTL1_IntegerVector

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32Vector, IntegerVector => Integer32Vector, &
       & IntegerVectorIterator => Integer32VectorIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64Vector, IntegerVector => Integer64Vector, &
       & IntegerVectorIterator => Integer64VectorIterator


#else

#  define _type type(integer)
#  define _vector IntegerVector
#  define _vectoriterator IntegerVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif

end module gFTL1_IntegerVector

module gFTL_IntegerVector
   use gFTL1_IntegerVector
end module gFTL_IntegerVector

module gFTL_StringLogicalMap

#include "types/key_deferredLengthString.inc"
#define _value type(logical)
#define _map StringLogicalMap
#define _iterator StringLogicalMapIterator
#define _pair StringLogicalPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_StringLogicalMap

module gFTL1_DoubleComplexVector

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Complex64Vector, only: DoubleComplexVector => Complex64Vector
  use gFTL1_Complex64Vector, only: DoubleComplexVectorIterator => Complex64VectorIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_Complex64Vector, only: DoubleComplexVector => Complex128Vector
  use gFTL1_Complex64Vector, only: DoubleComplexVectorIterator => Complex128VectorIterator

#else

#  define _type type(complex(kind=kind(0.d0)))
#  define _vector DoubleComplexVector
#  define _vectoriterator DoubleComplexVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL1_DoubleComplexVector

module gFTL_DoubleComplexVector
   use gFTL1_DoubleComplexVector
end module gFTL_DoubleComplexVector

module gFTL_IntegerIntegerMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer32Integer32Map, only: IntegerIntegerMap => Integer32Integer32Map
  use gFTL_Integer32Integer32Map, only: IntegerIntegerMapIterator => Integer32Integer32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64Integer64Map, only: IntegerIntegerMap => Integer64Integer64Map
  use gFTL_Integer64Integer64Map, only: IntegerIntegerMapIterator => Integer64Integer64MapIterator

#else

#  define _key type(integer)
#  define _value type(integer)
#  define _map IntegerIntegerMap
#  define _iterator IntegerIntegerMapIterator
#  define _pair IntegerIntegerPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerIntegerMap

module gFTL1_IntegerInteger32Map

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32Integer32Map, only: IntegerInteger32Map => Integer32Integer32Map
  use gFTL1_Integer32Integer32Map, only: IntegerInteger32MapIterator => Integer32Integer32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64Integer32Map, only: IntegerInteger32Map => Integer64Integer32Map
  use gFTL1_Integer64Integer32Map, only: IntegerInteger32MapIterator => Integer64Integer32MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT32
 
#  define _key type(integer)
#  define _value type(integer(kind=INT32))
#  define _map IntegerInteger32Map
#  define _iterator IntegerInteger32MapIterator
#  define _pair IntegerInteger32Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerInteger32Map

module gFTL_IntegerInteger32Map
   use gFTL1_IntegerInteger32Map
end module gFTL_IntegerInteger32Map

module gFTL1_LogicalVector

#define _type type(logical)
#define _vector LogicalVector
#define _vectoriterator LogicalVectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type

end module gFTL1_LogicalVector

module gFTL_LogicalVector
   use gFTL1_LogicalVector
end module gFTL_LogicalVector

module gFTL_ComplexVector

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL_Complex32Vector, only: ComplexVector => Complex32Vector
  use gFTL_Complex32Vector, only: ComplexVectorIterator => Complex32VectorIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL_Complex64Vector, only: ComplexVector => Complex64Vector
  use gFTL_Complex64Vector, only: ComplexVectorIterator => Complex64VectorIterator

#else

#  define _type type(complex)
#  define _vector ComplexVector
#  define _vectoriterator ComplexVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL_ComplexVector

module gFTL_IntegerComplex32Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32Complex32Map, only: IntegerComplex32Map => Integer32Complex32Map
   use gFTL_Integer32Complex32Map, only: IntegerComplex32MapIterator => Integer32Complex32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64Complex32Map, only: IntegerComplex32Map => Integer64Complex32Map
   use gFTL_Integer64Complex32Map, only: IntegerComplex32MapIterator => Integer64Complex32MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL32

#  define _key type(integer)
#  define _value type(complex(kind=REAL32))
#  define _map IntegerComplex32Map
#  define _iterator IntegerComplex32MapIterator
#  define _pair IntegerComplex32Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerComplex32Map

module gFTL_IntegerRealMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32RealMap, only: IntegerRealMap => Integer32RealMap
   use gFTL_Integer32RealMap, only: IntegerRealMapIterator => Integer32RealMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64RealMap, only: IntegerRealMap => Integer64RealMap
   use gFTL_Integer64RealMap, only: IntegerRealMapIterator => Integer64RealMapIterator

#else

#  define _key type(integer)
#  define _value type(real)
#  define _map IntegerRealMap
#  define _iterator IntegerRealMapIterator
#  define _pair IntegerRealPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerRealMap

module gFTL1_StringComplex32Map
  use, intrinsic:: iso_fortran_env, only: REAL32

#include "types/key_deferredLengthString.inc"
#define _value type(complex(kind=REAL32))
#define _map StringComplex32Map
#define _iterator StringComplex32MapIterator
#define _pair StringComplex32Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_StringComplex32Map

module gFTL_StringComplex32Map
   use gFTL1_StringComplex32Map
end module gFTL_StringComplex32Map

module gFTL1_IntegerIntegerMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32Integer32Map, only: IntegerIntegerMap => Integer32Integer32Map
  use gFTL1_Integer32Integer32Map, only: IntegerIntegerMapIterator => Integer32Integer32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64Integer64Map, only: IntegerIntegerMap => Integer64Integer64Map
  use gFTL1_Integer64Integer64Map, only: IntegerIntegerMapIterator => Integer64Integer64MapIterator

#else

#  define _key type(integer)
#  define _value type(integer)
#  define _map IntegerIntegerMap
#  define _iterator IntegerIntegerMapIterator
#  define _pair IntegerIntegerPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerIntegerMap

module gFTL_IntegerIntegerMap
   use gFTL1_IntegerIntegerMap
end module gFTL_IntegerIntegerMap

module gFTL_Integer64Real32Map
  use, intrinsic:: iso_fortran_env, only: INT64, REAL32

#define _key type(integer(kind=INT64))
#define _value type(real(kind=REAL32))
#define _map Integer64Real32Map
#define _iterator Integer64Real32MapIterator
#define _pair Integer64Real32Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_Integer64Real32Map

module gFTL1_Integer64Complex64Map
  use, intrinsic:: iso_fortran_env, only: INT64, REAL64

#define _key type(integer(kind=INT64))
#define _value type(complex(kind=REAL64))
#define _map Integer64Complex64Map
#define _iterator Integer64Complex64MapIterator
#define _pair Integer64Complex64Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_Integer64Complex64Map

module gFTL_Integer64Complex64Map
   use gFTL1_Integer64Complex64Map
end module gFTL_Integer64Complex64Map

module gFTL_StringReal128Map
  use, intrinsic:: iso_fortran_env, only: REAL128

#include "types/key_deferredLengthString.inc"
#define _value type(real(kind=REAL128))
#define _map StringReal128Map
#define _iterator StringReal128MapIterator
#define _pair StringReal128Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_StringReal128Map

module gFTL_IntegerReal128Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32Real128Map, only: IntegerReal128Map => Integer32Real128Map
   use gFTL_Integer32Real128Map, only: IntegerReal128MapIterator => Integer32Real128MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64Real128Map, only: IntegerReal128Map => Integer64Real128Map
   use gFTL_Integer64Real128Map, only: IntegerReal128MapIterator => Integer64Real128MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL128

#  define _key type(integer)
#  define _value type(real(kind=REAL128))
#  define _map IntegerReal128Map
#  define _iterator IntegerReal128MapIterator
#  define _pair IntegerReal128Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerReal128Map

module gFTL_Real128Vector
  use, intrinsic :: iso_fortran_env, only: REAL128

#define _type type(real(kind=REAL128))
#define _vector Real128Vector
#define _vectoriterator Real128VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL_Real128Vector

module gFTL1_UnlimitedVector

#include "types/unlimitedPoly.inc"
#define _vector UnlimitedVector
#define _vectoriterator UnlimitedVectorIterator

#include "templates/vector.inc"

#undef _vectoriterator
#undef _vector
#undef _type

end module gFTL1_UnlimitedVector

module gFTL_UnlimitedVector
   use gFTL1_UnlimitedVector
end module gFTL_UnlimitedVector

module gFTL_UnlimitedVector

#include "types/unlimitedPoly.inc"
#define _vector UnlimitedVector
#define _vectoriterator UnlimitedVectorIterator

#include "templates/vector.inc"

#undef _vectoriterator
#undef _vector
#undef _type

end module gFTL_UnlimitedVector

module gFTL_Integer64UnlimitedMap
  use, intrinsic:: iso_fortran_env, only: INT64

#define _key type(integer(kind=INT64))
#include "types/value_unlimitedPoly.inc"
#define _map Integer64UnlimitedMap
#define _iterator Integer64UnlimitedMapIterator
#define _pair Integer64UnlimitedPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_Integer64UnlimitedMap

module gFTL_IntegerDoubleMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32DoubleMap, only: IntegerDoubleMap => Integer32DoubleMap
   use gFTL_Integer32DoubleMap, only: IntegerDoubleMapIterator => Integer32DoubleMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64DoubleMap, only: IntegerDoubleMap => Integer64DoubleMap
   use gFTL_Integer64DoubleMap, only: IntegerDoubleMapIterator => Integer64DoubleMapIterator

#else

#  define _key type(integer)
#  define _value type(double precision)
#  define _map IntegerDoubleMap
#  define _iterator IntegerDoubleMapIterator
#  define _pair IntegerDoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerDoubleMap

module gFTL_Integer64DoubleComplexMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_Integer64Complex64Map, only: Integer64DoubleComplexMap => Integer64Complex64Map
  use gFTL_Integer64Complex64Map, only: Integer64DoubleComplexMapIterator => Integer64Complex64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_Integer64Complex128Map, only: Integer64DoubleComplexMap => Integer64Complex128Map
  use gFTL_Integer64Complex128Map, only: Integer64DoubleComplexMapIterator => Integer64Complex128MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(complex(kind=kind(0.0d0)))
#  define _map Integer64DoubleComplexMap
#  define _iterator Integer64DoubleComplexMapIterator
#  define _pair Integer64DoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_Integer64DoubleComplexMap

module gFTL1_Integer32Vector
  use, intrinsic :: iso_fortran_env, only: INT32

#define _type type(integer(kind=INT32))
#define _vector Integer32Vector
#define _vectoriterator Integer32VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL1_Integer32Vector

module gFTL_Integer32Vector
   use gFTL1_Integer32Vector
end module gFTL_Integer32Vector

module gFTL_StringDoubleMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_StringReal64Map, only: StringDoubleMap => StringReal64Map
  use gFTL_StringReal64Map, only: StringDoubleMapIterator => StringReal64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_StringReal128Map, only: StringDoubleMap => StringReal128Map
  use gFTL_StringReal128Map, only: StringDoubleMapIterator => StringReal128MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(double precision)
#  define _map StringDoubleMap
#  define _iterator StringDoubleMapIterator
#  define _pair StringDoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_StringDoubleMap

module gFTL1_DoubleVector

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Real64Vector, only: DoubleVector => Real64Vector
  use gFTL1_Real64Vector, only: DoubleVectorIterator => Real64VectorIterator

#elif defined (_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_Real128Vector, only: DoubleVector => Real128Vector
  use gFTL1_Real128Vector, only: DoubleVectorIterator => Real128VectorIterator

#else

#  define _type type(double precision)
#  define _vector DoubleVector
#  define _vectoriterator DoubleVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL1_DoubleVector

module gFTL_DoubleVector
   use gFTL1_DoubleVector
end module gFTL_DoubleVector

module gFTL_Real32Vector
  use, intrinsic :: iso_fortran_env, only: REAL32

#define _type type(real(kind=REAL32))
#define _vector Real32Vector
#define _vectoriterator Real32VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL_Real32Vector

module gFTL_StringVector

#include "types/deferredLengthString.inc"
#define _vector StringVector
#define _vectoriterator StringVectorIterator

#include "templates/vector.inc"

#undef _vectoriterator
#undef _vector
#undef _type

end module gFTL_StringVector

module gFTL1_Integer64DoubleMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_Integer64Real64Map, only: Integer64DoubleMap => Integer64Real64Map
  use gFTL1_Integer64Real64Map, only: Integer64DoubleMapIterator => Integer64Real64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_Integer64Real128Map, only: Integer64DoubleMap => Integer64Real128Map
  use gFTL1_Integer64Real128Map, only: Integer64DoubleMapIterator => Integer64Real128MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(double precision)
#  define _map Integer64DoubleMap
#  define _iterator Integer64DoubleMapIterator
#  define _pair Integer64DoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer64DoubleMap

module gFTL_Integer64DoubleMap
   use gFTL1_Integer64DoubleMap
end module gFTL_Integer64DoubleMap

module gFTL_Integer64IntegerMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer64Integer32Map, only: Integer64IntegerMap => Integer64Integer32Map
  use gFTL_Integer64Integer32Map, only: Integer64IntegerMapIterator => Integer64Integer32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64Integer64Map, only: Integer64IntegerMap => Integer64Integer64Map
  use gFTL_Integer64Integer64Map, only: Integer64IntegerMapIterator => Integer64Integer64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(integer)
#  define _map Integer64IntegerMap
#  define _iterator Integer64IntegerMapIterator
#  define _pair Integer64IntegerPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_Integer64IntegerMap

module gFTL_IntegerComplexMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32ComplexMap, only: IntegerComplexMap => Integer32ComplexMap
   use gFTL_Integer32ComplexMap, only: IntegerComplexMapIterator => Integer32ComplexMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64ComplexMap, only: IntegerComplexMap => Integer64ComplexMap
   use gFTL_Integer64ComplexMap, only: IntegerComplexMapIterator => Integer64ComplexMapIterator

#else

#  define _key type(integer)
#  define _value type(complex)
#  define _map IntegerComplexMap
#  define _iterator IntegerComplexMapIterator
#  define _pair IntegerComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerComplexMap

module gFTL1_IntegerComplex32Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32Complex32Map, only: IntegerComplex32Map => Integer32Complex32Map
   use gFTL1_Integer32Complex32Map, only: IntegerComplex32MapIterator => Integer32Complex32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64Complex32Map, only: IntegerComplex32Map => Integer64Complex32Map
   use gFTL1_Integer64Complex32Map, only: IntegerComplex32MapIterator => Integer64Complex32MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL32

#  define _key type(integer)
#  define _value type(complex(kind=REAL32))
#  define _map IntegerComplex32Map
#  define _iterator IntegerComplex32MapIterator
#  define _pair IntegerComplex32Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerComplex32Map

module gFTL_IntegerComplex32Map
   use gFTL1_IntegerComplex32Map
end module gFTL_IntegerComplex32Map

module gFTL_StringInteger64Map
  use, intrinsic:: iso_fortran_env, only: INT64

#include "types/key_deferredLengthString.inc"
#define _value type(integer(kind=INT64))
#define _map StringInteger64Map
#define _iterator StringInteger64MapIterator
#define _pair StringInteger64Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_StringInteger64Map

module gFTL1_StringDoubleMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_StringReal64Map, only: StringDoubleMap => StringReal64Map
  use gFTL1_StringReal64Map, only: StringDoubleMapIterator => StringReal64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_StringReal128Map, only: StringDoubleMap => StringReal128Map
  use gFTL1_StringReal128Map, only: StringDoubleMapIterator => StringReal128MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(double precision)
#  define _map StringDoubleMap
#  define _iterator StringDoubleMapIterator
#  define _pair StringDoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_StringDoubleMap

module gFTL_StringDoubleMap
   use gFTL1_StringDoubleMap
end module gFTL_StringDoubleMap

module gFTL1_Integer32LogicalMap
  use, intrinsic:: iso_fortran_env, only: INT32

#define _key type(integer(kind=INT32))
#define _value type(logical)
#define _map Integer32LogicalMap
#define _iterator Integer32LogicalMapIterator
#define _pair Integer32LogicalPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_Integer32LogicalMap

module gFTL_Integer32LogicalMap
   use gFTL1_Integer32LogicalMap
end module gFTL_Integer32LogicalMap

module gFTL_StringComplexMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL_StringComplex32Map, only: StringComplexMap => StringComplex32Map
  use gFTL_StringComplex32Map, only: StringComplexMapIterator => StringComplex32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL_StringComplex64Map, only: StringComplexMap => StringComplex64Map
  use gFTL_StringComplex64Map, only: StringComplexMapIterator => StringComplex64MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(complex)
#  define _map StringComplexMap
#  define _iterator StringComplexMapIterator
#  define _pair StringComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_StringComplexMap

module gFTL_DoubleComplexVector

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_Complex64Vector, only: DoubleComplexVector => Complex64Vector
  use gFTL_Complex64Vector, only: DoubleComplexVectorIterator => Complex64VectorIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_Complex64Vector, only: DoubleComplexVector => Complex128Vector
  use gFTL_Complex64Vector, only: DoubleComplexVectorIterator => Complex128VectorIterator

#else

#  define _type type(complex(kind=kind(0.d0)))
#  define _vector DoubleComplexVector
#  define _vectoriterator DoubleComplexVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL_DoubleComplexVector

module gFTL1_IntegerDoubleComplexMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32DoubleComplexMap, only: IntegerDoubleComplexMap => Integer32DoubleComplexMap
   use gFTL1_Integer32DoubleComplexMap, only: IntegerDoubleComplexMapIterator => Integer32DoubleComplexMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64DoubleComplexMap, only: IntegerDoubleComplexMap => Integer64DoubleComplexMap
   use gFTL1_Integer64DoubleComplexMap, only: IntegerDoubleComplexMapIterator => Integer64DoubleComplexMapIterator

#else

#  define _key type(integer)
#  define _value type(complex(kind=kind(0.d0)))
#  define _map IntegerDoubleComplexMap
#  define _iterator IntegerDoubleComplexMapIterator
#  define _pair IntegerDoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerDoubleComplexMap

module gFTL_IntegerDoubleComplexMap
   use gFTL1_IntegerDoubleComplexMap
end module gFTL_IntegerDoubleComplexMap

module gFTL1_Complex128Vector
  use, intrinsic :: iso_fortran_env, only: REAL128

#define _type type(complex(kind=REAL128))
#define _vector Complex128Vector
#define _vectoriterator Complex128VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL1_Complex128Vector

module gFTL_Complex128Vector
   use gFTL1_Complex128Vector
end module gFTL_Complex128Vector

module gFTL_DoubleVector

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_Real64Vector, only: DoubleVector => Real64Vector
  use gFTL_Real64Vector, only: DoubleVectorIterator => Real64VectorIterator

#elif defined (_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_Real128Vector, only: DoubleVector => Real128Vector
  use gFTL_Real128Vector, only: DoubleVectorIterator => Real128VectorIterator

#else

#  define _type type(double precision)
#  define _vector DoubleVector
#  define _vectoriterator DoubleVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif
  
end module gFTL_DoubleVector

module gFTL1_IntegerRealMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32RealMap, only: IntegerRealMap => Integer32RealMap
   use gFTL1_Integer32RealMap, only: IntegerRealMapIterator => Integer32RealMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64RealMap, only: IntegerRealMap => Integer64RealMap
   use gFTL1_Integer64RealMap, only: IntegerRealMapIterator => Integer64RealMapIterator

#else

#  define _key type(integer)
#  define _value type(real)
#  define _map IntegerRealMap
#  define _iterator IntegerRealMapIterator
#  define _pair IntegerRealPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerRealMap

module gFTL_IntegerRealMap
   use gFTL1_IntegerRealMap
end module gFTL_IntegerRealMap

module gFTL1_StringRealMap

#if defined(_REAL_DEFAULT_KIND_IS_REAL32)

  use gFTL1_StringReal32Map, only: StringRealMap => StringReal32Map
  use gFTL1_StringReal32Map, only: StringRealMapIterator => StringReal32MapIterator

#elif defined(_REAL_DEFAULT_KIND_IS_REAL64)

  use gFTL1_StringReal64Map, only: StringRealMap => StringReal64Map
  use gFTL1_StringReal64Map, only: StringRealMapIterator => StringReal64MapIterator

#else
   
#  include "types/key_deferredLengthString.inc"
#  define _value type(real)
#  define _map StringRealMap
#  define _iterator StringRealMapIterator
#  define _pair StringRealPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_StringRealMap

module gFTL_StringRealMap
   use gFTL1_StringRealMap
end module gFTL_StringRealMap
   

module gFTL1_IntegerUnlimitedMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer32UnlimitedMap, only: IntegerUnlimitedMap => Integer32UnlimitedMap
  use gFTL1_Integer32UnlimitedMap, only: IntegerUnlimitedMapIterator => Integer32UnlimitedMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64UnlimitedMap, only: IntegerUnlimitedMap => Integer64UnlimitedMap
  use gFTL1_Integer64UnlimitedMap, only: IntegerUnlimitedMapIterator => Integer64UnlimitedMapIterator

#else

 
#  define _key type(integer)
#  include "types/value_unlimitedPoly.inc"
#  define _map IntegerUnlimitedMap
#  define _iterator IntegerUnlimitedMapIterator
#  define _pair IntegerUnlimitedPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerUnlimitedMap

module gFTL_IntegerUnlimitedMap
   use gFTL1_IntegerUnlimitedMap
end module gFTL_IntegerUnlimitedMap

module gFTL_Integer64DoubleMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL_Integer64Real64Map, only: Integer64DoubleMap => Integer64Real64Map
  use gFTL_Integer64Real64Map, only: Integer64DoubleMapIterator => Integer64Real64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL_Integer64Real128Map, only: Integer64DoubleMap => Integer64Real128Map
  use gFTL_Integer64Real128Map, only: Integer64DoubleMapIterator => Integer64Real128MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(double precision)
#  define _map Integer64DoubleMap
#  define _iterator Integer64DoubleMapIterator
#  define _pair Integer64DoublePair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_Integer64DoubleMap

module gFTL_IntegerVector

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL_Integer32Vector, only: IntegerVector => Integer32Vector
  use gFTL_Integer32Vector, only: IntegerVectorIterator => Integer32VectorIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL_Integer64Vector, only: IntegerVector => Integer64Vector
  use gFTL_Integer64Vector, only: IntegerVectorIterator => Integer64VectorIterator

#else

#  define _type type(integer)
#  define _vector IntegerVector
#  define _vectoriterator IntegerVectorIterator
#  include "templates/vector.inc"
#  undef _vectoriterator
#  undef _vector
#  undef _type

#endif

end module gFTL_IntegerVector

module gFTL1_IntegerComplexMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32ComplexMap, only: IntegerComplexMap => Integer32ComplexMap
   use gFTL1_Integer32ComplexMap, only: IntegerComplexMapIterator => Integer32ComplexMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64ComplexMap, only: IntegerComplexMap => Integer64ComplexMap
   use gFTL1_Integer64ComplexMap, only: IntegerComplexMapIterator => Integer64ComplexMapIterator

#else

#  define _key type(integer)
#  define _value type(complex)
#  define _map IntegerComplexMap
#  define _iterator IntegerComplexMapIterator
#  define _pair IntegerComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerComplexMap

module gFTL_IntegerComplexMap
   use gFTL1_IntegerComplexMap
end module gFTL_IntegerComplexMap

module gFTL_IntegerDoubleComplexMap

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32DoubleComplexMap, only: IntegerDoubleComplexMap => Integer32DoubleComplexMap
   use gFTL_Integer32DoubleComplexMap, only: IntegerDoubleComplexMapIterator => Integer32DoubleComplexMapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64DoubleComplexMap, only: IntegerDoubleComplexMap => Integer64DoubleComplexMap
   use gFTL_Integer64DoubleComplexMap, only: IntegerDoubleComplexMapIterator => Integer64DoubleComplexMapIterator

#else

#  define _key type(integer)
#  define _value type(complex(kind=kind(0.d0)))
#  define _map IntegerDoubleComplexMap
#  define _iterator IntegerDoubleComplexMapIterator
#  define _pair IntegerDoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerDoubleComplexMap

module gFTL1_Integer64Integer32Map
  use, intrinsic:: iso_fortran_env, only: INT32, INT64

#define _key type(integer(kind=INT64))
#define _value type(integer(kind=INT32))
#define _map Integer64Integer32Map
#define _iterator Integer64Integer32MapIterator
#define _pair Integer64Integer32Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_Integer64Integer32Map

module gFTL_Integer64Integer32Map
   use gFTL1_Integer64Integer32Map
end module gFTL_Integer64Integer32Map

module gFTL1_Integer32Real32Map
  use, intrinsic:: iso_fortran_env, only: INT32, REAL32

#define _key type(integer(kind=INT32))
#define _value type(real(kind=REAL32))
#define _map Integer32Real32Map
#define _iterator Integer32Real32MapIterator
#define _pair Integer32Real32Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_Integer32Real32Map

module gFTL_Integer32Real32Map
   use gFTL1_Integer32Real32Map
end module gFTL_Integer32Real32Map

module gFTL1_Integer32Real128Map
  use, intrinsic:: iso_fortran_env, only: INT32, REAL128

#define _key type(integer(kind=INT32))
#define _value type(real(kind=REAL128))
#define _map Integer32Real128Map
#define _iterator Integer32Real128MapIterator
#define _pair Integer32Real128Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_Integer32Real128Map

module gFTL_Integer32Real128Map
   use gFTL1_Integer32Real128Map
end module gFTL_Integer32Real128Map

module gFTL1_StringLogicalMap

#include "types/key_deferredLengthString.inc"
#define _value type(logical)
#define _map StringLogicalMap
#define _iterator StringLogicalMapIterator
#define _pair StringLogicalPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_StringLogicalMap

module gFTL_StringLogicalMap
   use gFTL1_StringLogicalMap
end module gFTL_StringLogicalMap

module gFTL1_Integer64Vector
  use, intrinsic :: iso_fortran_env, only: INT64

#define _type type(integer(kind=INT64))
#define _vector Integer64Vector
#define _vectoriterator Integer64VectorIterator
#include "templates/vector.inc"
#undef _vectoriterator
#undef _vector
#undef _type
  
end module gFTL1_Integer64Vector

module gFTL_Integer64Vector
   use gFTL1_Integer64Vector
end module gFTL_Integer64Vector

module gFTL1_Integer64IntegerMap

#if defined(_INT_DEFAULT_KIND_IS_INT32)

  use gFTL1_Integer64Integer32Map, only: Integer64IntegerMap => Integer64Integer32Map
  use gFTL1_Integer64Integer32Map, only: Integer64IntegerMapIterator => Integer64Integer32MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

  use gFTL1_Integer64Integer64Map, only: Integer64IntegerMap => Integer64Integer64Map
  use gFTL1_Integer64Integer64Map, only: Integer64IntegerMapIterator => Integer64Integer64MapIterator

#else

  use, intrinsic :: iso_fortran_env, only: INT64
 
#  define _key type(integer(kind=INT64))
#  define _value type(integer)
#  define _map Integer64IntegerMap
#  define _iterator Integer64IntegerMapIterator
#  define _pair Integer64IntegerPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_Integer64IntegerMap

module gFTL_Integer64IntegerMap
   use gFTL1_Integer64IntegerMap
end module gFTL_Integer64IntegerMap

module gFTL_IntegerReal64Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL_Integer32Real64Map, only: IntegerReal64Map => Integer32Real64Map
   use gFTL_Integer32Real64Map, only: IntegerReal64MapIterator => Integer32Real64MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL_Integer64Real64Map, only: IntegerReal64Map => Integer64Real64Map
   use gFTL_Integer64Real64Map, only: IntegerReal64MapIterator => Integer64Real64MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL64

#  define _key type(integer)
#  define _value type(real(kind=REAL64))
#  define _map IntegerReal64Map
#  define _iterator IntegerReal64MapIterator
#  define _pair IntegerReal64Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL_IntegerReal64Map

module gFTL1_IntegerComplex128Map

   
#if defined(_INT_DEFAULT_KIND_IS_INT32)

   use gFTL1_Integer32Complex128Map, only: IntegerComplex128Map => Integer32Complex128Map
   use gFTL1_Integer32Complex128Map, only: IntegerComplex128MapIterator => Integer32Complex128MapIterator

#elif defined(_INT_DEFAULT_KIND_IS_INT64)

   use gFTL1_Integer64Complex128Map, only: IntegerComplex128Map => Integer64Complex128Map
   use gFTL1_Integer64Complex128Map, only: IntegerComplex128MapIterator => Integer64Complex128MapIterator

#else

   use, intrinsic :: iso_fortran_env, only: REAL128

#  define _key type(integer)
#  define _value type(complex(kind=REAL128))
#  define _map IntegerComplex128Map
#  define _iterator IntegerComplex128MapIterator
#  define _pair IntegerComplex128Pair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_IntegerComplex128Map

module gFTL_IntegerComplex128Map
   use gFTL1_IntegerComplex128Map
end module gFTL_IntegerComplex128Map

program main

   use, intrinsic :: iso_fortran_env, only: INT32
   use, intrinsic :: iso_fortran_env, only: INT64
   use, intrinsic :: iso_fortran_env, only: REAL32
   use, intrinsic :: iso_fortran_env, only: REAL64
   use, intrinsic :: iso_fortran_env, only: REAL128

   use gFTL_Integer32Vector    
   use gFTL_Integer64Vector    
   use gFTL_IntegerVector    

   use gFTL_Real32Vector     
   use gFTL_Real64Vector     
   use gFTL_Real128Vector    
   use gFTL_RealVector     
   use gFTL_DoubleVector     

   use gFTL_Complex32Vector       
   use gFTL_Complex64Vector
   use gFTL_Complex128Vector
   use gFTL_ComplexVector    
   use gFTL_DoubleComplexVector    

   use gFTL_LogicalVector    
   use gFTL_StringVector     
   use gFTL_UnlimitedVector                  


   use gFTL_Integer32Integer32Map   
   use gFTL_Integer32Integer64Map   
   use gFTL_Integer32IntegerMap   

   use gFTL_Integer32Real32Map    
   use gFTL_Integer32Real64Map    
   use gFTL_Integer32Real128Map    
   use gFTL_Integer32RealMap    
   use gFTL_Integer32DoubleMap    

   use gFTL_Integer32Complex32Map   
   use gFTL_Integer32Complex64Map   
   use gFTL_Integer32Complex128Map  
   use gFTL_Integer32ComplexMap    
   use gFTL_Integer32DoubleComplexMap

   use gFTL_Integer32LogicalMap    
   use gFTL_Integer32StringMap    
   use gFTL_Integer32UnlimitedMap   

   use gFTL_Integer64Integer32Map   
   use gFTL_Integer64Integer64Map   
   use gFTL_Integer64IntegerMap   

   use gFTL_Integer64Real32Map    
   use gFTL_Integer64Real64Map    
   use gFTL_Integer64Real128Map    
   use gFTL_Integer64RealMap    
   use gFTL_Integer64DoubleMap    

   use gFTL_Integer64Complex32Map   
   use gFTL_Integer64Complex64Map   
   use gFTL_Integer64Complex128Map  
   use gFTL_Integer64ComplexMap    
   use gFTL_Integer64DoubleComplexMap

   use gFTL_Integer64LogicalMap    
   use gFTL_Integer64StringMap    
   use gFTL_Integer64UnlimitedMap   


   use gFTL_IntegerInteger32Map   
   use gFTL_IntegerInteger64Map   
   use gFTL_IntegerIntegerMap   

   use gFTL_IntegerReal32Map    
   use gFTL_IntegerReal64Map    
   use gFTL_IntegerReal128Map    
   use gFTL_IntegerRealMap    
   use gFTL_IntegerDoubleMap    

   use gFTL_IntegerComplex32Map   
   use gFTL_IntegerComplex64Map   
   use gFTL_IntegerComplex128Map  
   use gFTL_IntegerComplexMap    
   use gFTL_IntegerDoubleComplexMap

   use gFTL_IntegerLogicalMap    
   use gFTL_IntegerStringMap    
   use gFTL_IntegerUnlimitedMap   

   use gFTL_StringInteger32Map   
   use gFTL_StringInteger64Map   
   use gFTL_StringIntegerMap   

   use gFTL_StringReal32Map    
   use gFTL_StringReal64Map    
   use gFTL_StringReal128Map    
   use gFTL_StringRealMap    
   use gFTL_StringDoubleMap    

   use gFTL_StringComplex32Map   
   use gFTL_StringComplex64Map   
   use gFTL_StringComplex128Map  
   use gFTL_StringComplexMap    
   use gFTL_StringDoubleComplexMap

   use gFTL_StringLogicalMap    
   use gFTL_StringStringMap    
   use gFTL_StringUnlimitedMap   



   
   implicit none




   type(Integer32Vector) :: Integer32_vector               
   type(Integer64Vector) :: Integer64_vector               
   type(IntegerVector) :: Integer_vector               

   type(Real32Vector) :: Real32_vector                
   type(Real64Vector) :: Real64_vector                
   type(Real128Vector) :: Real128_vector               
   type(RealVector) :: Real_vector                
   type(DoubleVector) :: Double_vector                

   type(Complex32Vector) :: Complex32_vector               
   type(Complex64Vector) :: Complex64_vector                    
   type(Complex128Vector) :: Complex128_vector                   
   type(ComplexVector) :: Complex_vector               
   type(DoubleComplexVector) :: DoubleComplex_vector               

   type(LogicalVector) :: Logical_vector               
   type(StringVector) :: String_vector                
   type(UnlimitedVector) :: Unlimited_vector                    


   type(Integer32Integer32Map) :: Integer32Integer32_map              
   type(Integer32Integer64Map) :: Integer32Integer64_map              
   type(Integer32IntegerMap) :: Integer32Integer_map                

   type(Integer32Real32Map) :: Integer32Real32_map               
   type(Integer32Real64Map) :: Integer32Real64_map               
   type(Integer32Real128Map) :: Integer32Real128_map               
   type(Integer32RealMap) :: Integer32Real_map               
   type(Integer32DoubleMap) :: Integer32Double_map               

   type(Integer32Complex32Map) :: Integer32Complex32_map              
   type(Integer32Complex64Map) :: Integer32Complex64_map              
   type(Integer32Complex128Map) :: Integer32Complex128_map             
   type(Integer32ComplexMap) :: Integer32Complex_map               
   type(Integer32DoubleComplexMap) :: Integer32DoubleComplex_map          

   type(Integer32LogicalMap) :: Integer32Logical_map               
   type(Integer32StringMap) :: Integer32String_map               
   type(Integer32UnlimitedMap) :: Integer32Unlimited_map              

   type(Integer64Integer32Map) :: Integer64Integer32_map              
   type(Integer64Integer64Map) :: Integer64Integer64_map              
   type(Integer64IntegerMap) :: Integer64Integer_map                

   type(Integer64Real32Map) :: Integer64Real32_map               
   type(Integer64Real64Map) :: Integer64Real64_map               
   type(Integer64Real128Map) :: Integer64Real128_map               
   type(Integer64RealMap) :: Integer64Real_map               
   type(Integer64DoubleMap) :: Integer64Double_map               

   type(Integer64Complex32Map) :: Integer64Complex32_map              
   type(Integer64Complex64Map) :: Integer64Complex64_map              
   type(Integer64Complex128Map) :: Integer64Complex128_map             
   type(Integer64ComplexMap) :: Integer64Complex_map               
   type(Integer64DoubleComplexMap) :: Integer64DoubleComplex_map          

   type(Integer64LogicalMap) :: Integer64Logical_map               
   type(Integer64StringMap) :: Integer64String_map               
   type(Integer64UnlimitedMap) :: Integer64Unlimited_map              


   type(IntegerInteger32Map) :: IntegerInteger32_map                
   type(IntegerInteger64Map) :: IntegerInteger64_map                
   type(IntegerIntegerMap) :: IntegerInteger_map                  

   type(IntegerReal32Map) :: IntegerReal32_map               
   type(IntegerReal64Map) :: IntegerReal64_map               
   type(IntegerReal128Map) :: IntegerReal128_map               
   type(IntegerRealMap) :: IntegerReal_map               
   type(IntegerDoubleMap) :: IntegerDouble_map               

   type(IntegerComplex32Map) :: IntegerComplex32_map                
   type(IntegerComplex64Map) :: IntegerComplex64_map                
   type(IntegerComplex128Map) :: IntegerComplex128_map               
   type(IntegerComplexMap) :: IntegerComplex_map               
   type(IntegerDoubleComplexMap) :: IntegerDoubleComplex_map            

   type(IntegerLogicalMap) :: IntegerLogical_map               
   type(IntegerStringMap) :: IntegerString_map               
   type(IntegerUnlimitedMap) :: IntegerUnlimited_map                

   type(StringInteger32Map) :: StringInteger32_map                 
   type(StringInteger64Map) :: StringInteger64_map                 
   type(StringIntegerMap) :: StringInteger_map                   

   type(StringReal32Map) :: StringReal32_map               
   type(StringReal64Map) :: StringReal64_map               
   type(StringReal128Map) :: StringReal128_map               
   type(StringRealMap) :: StringReal_map               
   type(StringDoubleMap) :: StringDouble_map               

   type(StringComplex32Map) :: StringComplex32_map                 
   type(StringComplex64Map) :: StringComplex64_map                 
   type(StringComplex128Map) :: StringComplex128_map                
   type(StringComplexMap) :: StringComplex_map               
   type(StringDoubleComplexMap) :: StringDoubleComplex_map             

   type(StringLogicalMap) :: StringLogical_map               
   type(StringStringMap) :: StringString_map               
   type(StringUnlimitedMap) :: StringUnlimited_map                 















   call Integer32_vector%push_back(1_INT32)    
   call Integer64_vector%push_back(1_INT64)    
   call Integer_vector%push_back(1)    

   call Real32_vector%push_back(1._REAL32)     
   call Real64_vector%push_back(1._REAL64)
#ifdef _ISO_REAL128
   call Real128_vector%push_back(1._REAL128)
#endif
   call Real_vector%push_back(1.)     
   call Double_vector%push_back(1.d0)     

   call Complex32_vector%push_back((1._REAL32,2._REAL32))
   call Complex64_vector%push_back((1._REAL64,2._REAL64))
#ifdef _ISO_REAL128
   call Complex128_vector%push_back((1._REAL128,2._REAL128))
#endif
   call Complex_vector%push_back((1.,2.))
   call DoubleComplex_vector%push_back((1.d0,2.d0))

   call Logical_vector%push_back(.true.)    
   call String_vector%push_back('fido')     

   call Unlimited_vector%push_back(1)
   call Unlimited_vector%push_back(1.)
   call Unlimited_vector%push_back(.true.)
   call Unlimited_vector%push_back('string')
   


   call Integer32Integer32_map%insert(1_INT32, 2_INT32)   
   call Integer32Integer64_map%insert(1_INT32, 2_INT64)   
   call Integer32Integer_map%insert(1_INT32, 2)

   Integer32Integer_map = Integer32Integer32_map

   call Integer32Real32_map%insert(1_INT32, 2._REAL32)    
   call Integer32Real64_map%insert(1_INT32, 2._REAL64)    
#ifdef _ISO_REAL128
   call Integer32Real128_map%insert(1_INT32, 2._REAL128)
#endif
   call Integer32Real_map%insert(1_INT32, 2.)
   call Integer32Double_map%insert(1_INT32, 2.d0)

   call Integer32Complex32_map%insert(1_INT32, (2._REAL32,3._REAL32))
   call Integer32Complex64_map%insert(1_INT32, (2._REAL64,3._REAL64))   
#ifdef _ISO_REAL128
   call Integer32Complex128_map%insert(1_INT32, (2._REAL128,3._REAL128))
#endif
   call Integer32Complex_map%insert(1_INT32, (2.,3.))
   call Integer32DoubleComplex_map%insert(1_INT32, (2.d0,3.d0))

   call Integer32Logical_map%insert(1_INT32, .true.)    
   call Integer32String_map%insert(1_INT32, 'spot')    

   call Integer32Unlimited_map%insert(1_INT32,2)   
   call Integer32Unlimited_map%insert(1_INT32,2.)   
   call Integer32Unlimited_map%insert(1_INT32,'string')





   call Integer64Integer32_map%insert(1_INT64, 2_INT32)   
   call Integer64Integer64_map%insert(1_INT64, 2_INT64)   
   call Integer64Integer_map%insert(1_INT64, 2)   

   call Integer64Real32_map%insert(1_INT64, 2._REAL32)    
   call Integer64Real64_map%insert(1_INT64, 2._REAL64)    
#ifdef _ISO_REAL128
   call Integer64Real128_map%insert(1_INT64, 2._REAL128)
#endif
   call Integer64Real_map%insert(1_INT64, 2.)
   call Integer64Double_map%insert(1_INT64, 2.d0)

   call Integer64Complex32_map%insert(1_INT64, (2._REAL32,3._REAL32))
   call Integer64Complex64_map%insert(1_INT64, (2._REAL64,3._REAL64))   
#ifdef _ISO_REAL128
   call Integer64Complex128_map%insert(1_INT64, (2._REAL128,3._REAL128))
#endif
   call Integer64Complex_map%insert(1_INT64, (2.,3.))
   call Integer64DoubleComplex_map%insert(1_INT64, (2.d0,3.d0))

   call Integer64Logical_map%insert(1_INT64, .true.)    
   call Integer64String_map%insert(1_INT64, 'spot')    

   call Integer64Unlimited_map%insert(1_INT64,2)   
   call Integer64Unlimited_map%insert(1_INT64,2.)   
   call Integer64Unlimited_map%insert(1_INT64,'string')



   call IntegerInteger32_map%insert(1, 2_INT32)   
   call IntegerInteger64_map%insert(1, 2_INT64)   
   call IntegerInteger_map%insert(1, 2)   

   call IntegerReal32_map%insert(1, 2._REAL32)    
   call IntegerReal64_map%insert(1, 2._REAL64)    
#ifdef _ISO_REAL128
   call IntegerReal128_map%insert(1, 2._REAL128)
#endif
   call IntegerReal_map%insert(1, 2.)
   call IntegerDouble_map%insert(1, 2.d0)

   call IntegerComplex32_map%insert(1, (2._REAL32,3._REAL32))
   call IntegerComplex64_map%insert(1, (2._REAL64,3._REAL64))   
#ifdef _ISO_REAL128
   call IntegerComplex128_map%insert(1, (2._REAL128,3._REAL128))
#endif
   call IntegerComplex_map%insert(1, (2.,3.))
   call IntegerDoubleComplex_map%insert(1, (2.d0,3.d0))

   call IntegerLogical_map%insert(1, .true.)    
   call IntegerString_map%insert(1, 'spot')    

   call IntegerUnlimited_map%insert(1,2)   
   call IntegerUnlimited_map%insert(1,2.)   
   call IntegerUnlimited_map%insert(1,'string')







   call StringInteger32_map%insert('A', 2_INT32)   
   call StringInteger64_map%insert('A', 2_INT64)   
   call StringInteger_map%insert('A', 2)   

   call StringReal32_map%insert('A', 2._REAL32)    
   call StringReal64_map%insert('A', 2._REAL64)    
#ifdef _ISO_REAL128
   call StringReal128_map%insert('A', 2._REAL128)
#endif
   call StringReal_map%insert('A', 2.)
   call StringDouble_map%insert('A', 2.d0)

   call StringComplex32_map%insert('A', (2._REAL32,3._REAL32))
   call StringComplex64_map%insert('A', (2._REAL64,3._REAL64))   
#ifdef _ISO_REAL128
   call StringComplex128_map%insert('A', (2._REAL128,3._REAL128))
#endif
   call StringComplex_map%insert('A', (2.,3.))
   call StringDoubleComplex_map%insert('A', (2.d0,3.d0))

   call StringLogical_map%insert('A', .true.)    
   call StringString_map%insert('A', 'spot')    

   call StringUnlimited_map%insert('A',2)   
   call StringUnlimited_map%insert('A',2.)   
   call StringUnlimited_map%insert('A','string')



end program main

module gFTL1_StringDoubleComplexMap

#if defined(_DOUBLE_DEFAULT_KIND_IS_REAL64)

  use gFTL1_StringComplex64Map, only: StringDoubleComplexMap => StringComplex64Map
  use gFTL1_StringComplex64Map, only: StringDoubleComplexMapIterator => StringComplex64MapIterator

#elif defined(_DOUBLE_DEFAULT_KIND_IS_REAL128)

  use gFTL1_StringComplex128Map, only: StringDoubleComplexMap => StringComplex128Map
  use gFTL1_StringComplex128Map, only: StringDoubleComplexMapIterator => StringComplex128MapIterator

#else
  
 
#  include "types/key_deferredLengthString.inc"
#  define _value type(complex(kind=kind(0.0d0)))
#  define _map StringDoubleComplexMap
#  define _iterator StringDoubleComplexMapIterator
#  define _pair StringDoubleComplexPair
#  define _alt

#  include "templates/map.inc"

#  undef _alt
#  undef _iterator
#  undef _map
#  undef _value
#  undef _key

#endif

end module gFTL1_StringDoubleComplexMap

module gFTL_StringDoubleComplexMap
   use gFTL1_StringDoubleComplexMap
end module gFTL_StringDoubleComplexMap

module gFTL_Integer32UnlimitedMap
  use, intrinsic:: iso_fortran_env, only: INT32

#define _key type(integer(kind=INT32))
#include "types/value_unlimitedPoly.inc"
#define _map Integer32UnlimitedMap
#define _iterator Integer32UnlimitedMapIterator
#define _pair Integer32UnlimitedPair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL_Integer32UnlimitedMap

module gFTL1_StringReal64Map
  use, intrinsic:: iso_fortran_env, only: REAL64

#include "types/key_deferredLengthString.inc"
#define _value type(real(kind=REAL64))
#define _map StringReal64Map
#define _iterator StringReal64MapIterator
#define _pair StringReal64Pair
#define _alt

#include "templates/map.inc"

#undef _alt
#undef _iterator
#undef _map
#undef _value
#undef _key  

end module gFTL1_StringReal64Map

module gFTL_StringReal64Map
   use gFTL1_StringReal64Map
end module gFTL_StringReal64Map

program main

   use, intrinsic :: iso_fortran_env, only: INT32
   use, intrinsic :: iso_fortran_env, only: INT64
   use, intrinsic :: iso_fortran_env, only: REAL32
   use, intrinsic :: iso_fortran_env, only: REAL64
#ifdef _ISO_REAL128
   use, intrinsic :: iso_fortran_env, only: REAL128
#endif

   use gFTL1_Integer32Vector
   use gFTL1_Integer64Vector
   use gFTL1_IntegerVector

   use gFTL1_Real32Vector
   use gFTL1_Real64Vector
#ifdef _ISO_REAL128
   use gFTL1_Real128Vector
#endif
   use gFTL1_RealVector
   use gFTL1_DoubleVector

   use gFTL1_Complex32Vector
   use gFTL1_Complex64Vector
#ifdef _ISO_REAL128
   use gFTL1_Complex128Vector
#endif
   use gFTL1_ComplexVector
   use gFTL1_DoubleComplexVector

   use gFTL1_LogicalVector
   use gFTL1_StringVector
   use gFTL1_UnlimitedVector


   use gFTL1_Integer32Integer32Map
   use gFTL1_Integer32Integer64Map
   use gFTL1_Integer32IntegerMap

   use gFTL1_Integer32Real32Map
   use gFTL1_Integer32Real64Map
#ifdef _ISO_REAL128
   use gFTL1_Integer32Real128Map
#endif
   use gFTL1_Integer32RealMap
   use gFTL1_Integer32DoubleMap

   use gFTL1_Integer32Complex32Map
   use gFTL1_Integer32Complex64Map
#ifdef _ISO_REAL128
   use gFTL1_Integer32Complex128Map
#endif
   use gFTL1_Integer32ComplexMap
   use gFTL1_Integer32DoubleComplexMap

   use gFTL1_Integer32LogicalMap
   use gFTL1_Integer32StringMap
   use gFTL1_Integer32UnlimitedMap

   use gFTL1_Integer64Integer32Map
   use gFTL1_Integer64Integer64Map
   use gFTL1_Integer64IntegerMap

   use gFTL1_Integer64Real32Map
   use gFTL1_Integer64Real64Map
#ifdef _ISO_REAL128
   use gFTL1_Integer64Real128Map
#endif
   use gFTL1_Integer64RealMap
   use gFTL1_Integer64DoubleMap

   use gFTL1_Integer64Complex32Map
   use gFTL1_Integer64Complex64Map
#ifdef _ISO_REAL128
   use gFTL1_Integer64Complex128Map
#endif
   use gFTL1_Integer64ComplexMap
   use gFTL1_Integer64DoubleComplexMap

   use gFTL1_Integer64LogicalMap
   use gFTL1_Integer64StringMap
   use gFTL1_Integer64UnlimitedMap


   use gFTL1_IntegerInteger32Map
   use gFTL1_IntegerInteger64Map
   use gFTL1_IntegerIntegerMap

   use gFTL1_IntegerReal32Map
   use gFTL1_IntegerReal64Map
#ifdef _ISO_REAL128
   use gFTL1_IntegerReal128Map
#endif
   use gFTL1_IntegerRealMap
   use gFTL1_IntegerDoubleMap

   use gFTL1_IntegerComplex32Map
   use gFTL1_IntegerComplex64Map
#ifdef _ISO_REAL128
   use gFTL1_IntegerComplex128Map
#endif
   use gFTL1_IntegerComplexMap
   use gFTL1_IntegerDoubleComplexMap

   use gFTL1_IntegerLogicalMap
   use gFTL1_IntegerStringMap
   use gFTL1_IntegerUnlimitedMap

   use gFTL1_StringInteger32Map
   use gFTL1_StringInteger64Map
   use gFTL1_StringIntegerMap

   use gFTL1_StringReal32Map
   use gFTL1_StringReal64Map
#ifdef _ISO_REAL128
   use gFTL1_StringReal128Map
#endif
   use gFTL1_StringRealMap
   use gFTL1_StringDoubleMap

   use gFTL1_StringComplex32Map
   use gFTL1_StringComplex64Map
#ifdef _ISO_REAL128
   use gFTL1_StringComplex128Map
#endif
   use gFTL1_StringComplexMap
   use gFTL1_StringDoubleComplexMap

   use gFTL1_StringLogicalMap
   use gFTL1_StringStringMap
   use gFTL1_StringUnlimitedMap




   implicit none




   type(Integer32Vector) :: Integer32_vector
   type(Integer64Vector) :: Integer64_vector
   type(IntegerVector) :: Integer_vector

   type(Real32Vector) :: Real32_vector
   type(Real64Vector) :: Real64_vector
#ifdef _ISO_REAL128
   type(Real128Vector) :: Real128_vector
#endif
   type(RealVector) :: Real_vector
   type(DoubleVector) :: Double_vector

   type(Complex32Vector) :: Complex32_vector
   type(Complex64Vector) :: Complex64_vector
#ifdef _ISO_REAL128
   type(Complex128Vector) :: Complex128_vector
#endif
   type(ComplexVector) :: Complex_vector
   type(DoubleComplexVector) :: DoubleComplex_vector

   type(LogicalVector) :: Logical_vector
   type(StringVector) :: String_vector
   type(UnlimitedVector) :: Unlimited_vector


   type(Integer32Integer32Map) :: Integer32Integer32_map
   type(Integer32Integer64Map) :: Integer32Integer64_map
   type(Integer32IntegerMap) :: Integer32Integer_map

   type(Integer32Real32Map) :: Integer32Real32_map
   type(Integer32Real64Map) :: Integer32Real64_map
#ifdef _ISO_REAL128
   type(Integer32Real128Map) :: Integer32Real128_map
#endif
   type(Integer32RealMap) :: Integer32Real_map
   type(Integer32DoubleMap) :: Integer32Double_map

   type(Integer32Complex32Map) :: Integer32Complex32_map
   type(Integer32Complex64Map) :: Integer32Complex64_map
#ifdef _ISO_REAL128
   type(Integer32Complex128Map) :: Integer32Complex128_map
#endif
   type(Integer32ComplexMap) :: Integer32Complex_map
   type(Integer32DoubleComplexMap) :: Integer32DoubleComplex_map

   type(Integer32LogicalMap) :: Integer32Logical_map
   type(Integer32StringMap) :: Integer32String_map
   type(Integer32UnlimitedMap) :: Integer32Unlimited_map

   type(Integer64Integer32Map) :: Integer64Integer32_map
   type(Integer64Integer64Map) :: Integer64Integer64_map
   type(Integer64IntegerMap) :: Integer64Integer_map

   type(Integer64Real32Map) :: Integer64Real32_map
   type(Integer64Real64Map) :: Integer64Real64_map
#ifdef _ISO_REAL128
   type(Integer64Real128Map) :: Integer64Real128_map
#endif
   type(Integer64RealMap) :: Integer64Real_map
   type(Integer64DoubleMap) :: Integer64Double_map

   type(Integer64Complex32Map) :: Integer64Complex32_map
   type(Integer64Complex64Map) :: Integer64Complex64_map
#ifdef _ISO_REAL128
   type(Integer64Complex128Map) :: Integer64Complex128_map
#endif
   type(Integer64ComplexMap) :: Integer64Complex_map
   type(Integer64DoubleComplexMap) :: Integer64DoubleComplex_map

   type(Integer64LogicalMap) :: Integer64Logical_map
   type(Integer64StringMap) :: Integer64String_map
   type(Integer64UnlimitedMap) :: Integer64Unlimited_map


   type(IntegerInteger32Map) :: IntegerInteger32_map
   type(IntegerInteger64Map) :: IntegerInteger64_map
   type(IntegerIntegerMap) :: IntegerInteger_map

   type(IntegerReal32Map) :: IntegerReal32_map
   type(IntegerReal64Map) :: IntegerReal64_map
#ifdef _ISO_REAL128
   type(IntegerReal128Map) :: IntegerReal128_map
#endif
   type(IntegerRealMap) :: IntegerReal_map
   type(IntegerDoubleMap) :: IntegerDouble_map

   type(IntegerComplex32Map) :: IntegerComplex32_map
   type(IntegerComplex64Map) :: IntegerComplex64_map
#ifdef _ISO_REAL128
   type(IntegerComplex128Map) :: IntegerComplex128_map
#endif
   type(IntegerComplexMap) :: IntegerComplex_map
   type(IntegerDoubleComplexMap) :: IntegerDoubleComplex_map

   type(IntegerLogicalMap) :: IntegerLogical_map
   type(IntegerStringMap) :: IntegerString_map
   type(IntegerUnlimitedMap) :: IntegerUnlimited_map

   type(StringInteger32Map) :: StringInteger32_map
   type(StringInteger64Map) :: StringInteger64_map
   type(StringIntegerMap) :: StringInteger_map

   type(StringReal32Map) :: StringReal32_map
   type(StringReal64Map) :: StringReal64_map
#ifdef _ISO_REAL128
   type(StringReal128Map) :: StringReal128_map
#endif
   type(StringRealMap) :: StringReal_map
   type(StringDoubleMap) :: StringDouble_map

   type(StringComplex32Map) :: StringComplex32_map
   type(StringComplex64Map) :: StringComplex64_map
#ifdef _ISO_REAL128
   type(StringComplex128Map) :: StringComplex128_map
#endif
   type(StringComplexMap) :: StringComplex_map
   type(StringDoubleComplexMap) :: StringDoubleComplex_map

   type(StringLogicalMap) :: StringLogical_map
   type(StringStringMap) :: StringString_map
   type(StringUnlimitedMap) :: StringUnlimited_map



   call Integer32_vector%push_back(1_INT32)
   call Integer64_vector%push_back(1_INT64)
   call Integer_vector%push_back(1)

   call Real32_vector%push_back(1._REAL32)
   call Real64_vector%push_back(1._REAL64)
#ifdef _ISO_REAL128
   call Real128_vector%push_back(1._REAL128)
#endif
   call Real_vector%push_back(1.)
   call Double_vector%push_back(1.d0)

   call Complex32_vector%push_back((1._REAL32,2._REAL32))
   call Complex64_vector%push_back((1._REAL64,2._REAL64))
#ifdef _ISO_REAL128
   call Complex128_vector%push_back((1._REAL128,2._REAL128))
#endif
   call Complex_vector%push_back((1.,2.))
   call DoubleComplex_vector%push_back((1.d0,2.d0))

   call Logical_vector%push_back(.true.)
   call String_vector%push_back('fido')

   call Unlimited_vector%push_back(1)
   call Unlimited_vector%push_back(1.)
   call Unlimited_vector%push_back(.true.)
   call Unlimited_vector%push_back('string')



   call Integer32Integer32_map%insert(1_INT32, 2_INT32)
   call Integer32Integer64_map%insert(1_INT32, 2_INT64)
   call Integer32Integer_map%insert(1_INT32, 2)

   Integer32Integer_map = Integer32Integer32_map

   call Integer32Real32_map%insert(1_INT32, 2._REAL32)
   call Integer32Real64_map%insert(1_INT32, 2._REAL64)
#ifdef _ISO_REAL128
   call Integer32Real128_map%insert(1_INT32, 2._REAL128)
#endif
   call Integer32Real_map%insert(1_INT32, 2.)
   call Integer32Double_map%insert(1_INT32, 2.d0)

   call Integer32Complex32_map%insert(1_INT32, (2._REAL32,3._REAL32))
   call Integer32Complex64_map%insert(1_INT32, (2._REAL64,3._REAL64))
#ifdef _ISO_REAL128
   call Integer32Complex128_map%insert(1_INT32, (2._REAL128,3._REAL128))
#endif
   call Integer32Complex_map%insert(1_INT32, (2.,3.))
   call Integer32DoubleComplex_map%insert(1_INT32, (2.d0,3.d0))

   call Integer32Logical_map%insert(1_INT32, .true.)
   call Integer32String_map%insert(1_INT32, 'spot')

   call Integer32Unlimited_map%insert(1_INT32,2)
   call Integer32Unlimited_map%insert(1_INT32,2.)
   call Integer32Unlimited_map%insert(1_INT32,'string')



   call Integer64Integer32_map%insert(1_INT64, 2_INT32)
   call Integer64Integer64_map%insert(1_INT64, 2_INT64)
   call Integer64Integer_map%insert(1_INT64, 2)

   call Integer64Real32_map%insert(1_INT64, 2._REAL32)
   call Integer64Real64_map%insert(1_INT64, 2._REAL64)
#ifdef _ISO_REAL128
   call Integer64Real128_map%insert(1_INT64, 2._REAL128)
#endif
   call Integer64Real_map%insert(1_INT64, 2.)
   call Integer64Double_map%insert(1_INT64, 2.d0)

   call Integer64Complex32_map%insert(1_INT64, (2._REAL32,3._REAL32))
   call Integer64Complex64_map%insert(1_INT64, (2._REAL64,3._REAL64))
#ifdef _ISO_REAL128
   call Integer64Complex128_map%insert(1_INT64, (2._REAL128,3._REAL128))
#endif
   call Integer64Complex_map%insert(1_INT64, (2.,3.))
   call Integer64DoubleComplex_map%insert(1_INT64, (2.d0,3.d0))

   call Integer64Logical_map%insert(1_INT64, .true.)
   call Integer64String_map%insert(1_INT64, 'spot')

   call Integer64Unlimited_map%insert(1_INT64,2)
   call Integer64Unlimited_map%insert(1_INT64,2.)
   call Integer64Unlimited_map%insert(1_INT64,'string')



   call IntegerInteger32_map%insert(1, 2_INT32)
   call IntegerInteger64_map%insert(1, 2_INT64)
   call IntegerInteger_map%insert(1, 2)

   call IntegerReal32_map%insert(1, 2._REAL32)
   call IntegerReal64_map%insert(1, 2._REAL64)
#ifdef _ISO_REAL128
   call IntegerReal128_map%insert(1, 2._REAL128)
#endif
   call IntegerReal_map%insert(1, 2.)
   call IntegerDouble_map%insert(1, 2.d0)

   call IntegerComplex32_map%insert(1, (2._REAL32,3._REAL32))
   call IntegerComplex64_map%insert(1, (2._REAL64,3._REAL64))
#ifdef _ISO_REAL128
   call IntegerComplex128_map%insert(1, (2._REAL128,3._REAL128))
#endif
   call IntegerComplex_map%insert(1, (2.,3.))
   call IntegerDoubleComplex_map%insert(1, (2.d0,3.d0))

   call IntegerLogical_map%insert(1, .true.)
   call IntegerString_map%insert(1, 'spot')

   call IntegerUnlimited_map%insert(1,2)
   call IntegerUnlimited_map%insert(1,2.)
   call IntegerUnlimited_map%insert(1,'string')



   call StringInteger32_map%insert('A', 2_INT32)
   call StringInteger64_map%insert('A', 2_INT64)
   call StringInteger_map%insert('A', 2)

   call StringReal32_map%insert('A', 2._REAL32)
   call StringReal64_map%insert('A', 2._REAL64)
#ifdef _ISO_REAL128
   call StringReal128_map%insert('A', 2._REAL128)
#endif
   call StringReal_map%insert('A', 2.)
   call StringDouble_map%insert('A', 2.d0)

   call StringComplex32_map%insert('A', (2._REAL32,3._REAL32))
   call StringComplex64_map%insert('A', (2._REAL64,3._REAL64))
#ifdef _ISO_REAL128
   call StringComplex128_map%insert('A', (2._REAL128,3._REAL128))
#endif
   call StringComplex_map%insert('A', (2.,3.))
   call StringDoubleComplex_map%insert('A', (2.d0,3.d0))

   call StringLogical_map%insert('A', .true.)
   call StringString_map%insert('A', 'spot')

   call StringUnlimited_map%insert('A',2)
   call StringUnlimited_map%insert('A',2.)
   call StringUnlimited_map%insert('A','string')



end program main

# Contributing to gFTL-shared

Contributing code to gFTL-shared should be done via a Pull Request to this repository.

## Contributor License Agreement (CLA)

All external developers contributing to GFE projects must complete a [Contributor License
Agreement](https://github.com/Goddard-Fortran-Ecosystem/cla).


## License

By contributing to gFTL-shared, you agree your contributions will be
licensed under the [Apache 2.0 license](https://github.com/Goddard-Fortran-Ecosystem/gFTL/blob/main/License.txt)
